// (c) by Sitsanlis Ilias All rights reserved

var ic=10;
var rc=10;
var dx=720//window.innerWidth;
var dy=400//window.innerHeight;

var container;
var camera, scene, renderer;
var controls;
var BVecY2, BVec, plane;
var angle;
var B=2.5;
var dLB=6*5/B;
var nB=Math.round(25/dLB);
var toRad=Math.PI/180
var fieldShowFlag
var θ=0
var A=1
    
 var myControls = new function() {
    this['Γωνία περιστροφής'] = 0;
    this['Ένταση Μαγνητικού πεδίου (mT)'] = B;
  	this['Εμβαδό Επιφάνειας (m2)'] = A;
    this['Εμφάνιση Δυναμικών Γραμμών'] = false;
}
var gui

// ΑΡΧΙΚΟΠΟΙΗΣΗ
function initilaze() {
	init();
	animate();
	//restart();
}

function init() {
	container = document.getElementById("myCamvas");

	// ΠΡΟΣΘΗΚΗ ΣΚΗΝΗΣ
	scene = new THREE.Scene();
	//scene.rotation.set(0,0,Math.PI/2)

	// Η camera
	camera = new THREE.PerspectiveCamera( 40, dx/dy, 1, 2000 );
	camera.position.set( 70, 60, 70 );
	//camera.rotation.set(Math.PI/2,0,0)
	//scene.add( camera );
	//camera.position.y = 100;
	//camera.position.z = 90;
	//camera.position.y = -90;
	//camera.position.x = 100;

	

	
	var customContainer = document.getElementById('gui');
	gui = new dat.GUI( { autoPlace: false } )
	customContainer.appendChild(gui.domElement);
	
	var rotX = gui.add(myControls, 'Γωνία περιστροφής').min(-180).max(180).step(1);
	var rotZ = gui.add(myControls, 'Ένταση Μαγνητικού πεδίου (mT)').min(0).max(5);
	var rotA = gui.add(myControls, 'Εμβαδό Επιφάνειας (m2)').min(1).max(4).step(.1);;
	var fieldShow = gui.add(myControls, 'Εμφάνιση Δυναμικών Γραμμών');
	
	gui.close();
	gui.width=722;

	rotX.onFinishChange(function(value) {
  		myControls['Γωνία περιστροφής'] = 15*Math.round(value/15)
		for (var i=1;i<=2;i++) {
    		gui.__controllers[i].updateDisplay();
  		}
		θ=15*Math.round(value/15)
  		updateAngle(θ*toRad);
		document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb";
	});
	rotZ.onFinishChange(function(value) {
		B=value;
  		drawMagneticField();
	});
	

	fieldShow.onFinishChange(function(value) {
		fieldShowFlag=value;
  		drawMagneticField();
	});
	

	rotX.onChange(function(value) {
		θ=value
  		updateAngle(θ*toRad);
		document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	});
	rotZ.onChange(function(value) {
		B=value;
		document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
  		drawMagneticField();
	});
	rotA.onChange(function(value) {
		A=value;
		var x=Math.sqrt(A)
		plane.scale.x=x
		plane.scale.z=x
		if (nB!=Math.round(Math.sqrt(A)*25/dLB) && fieldShowFlag) {
			drawMagneticField();
		}
		
		document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	});
	rotA.onFinishChange(function(value) {
  		//drawMagneticField();
		//document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	});


	// ΦΩΤΙΣΜΟΣ
	scene.add( new THREE.AmbientLight( 0xffffff ) );

	// ΔΗΜΙΟΥΡΓΙΑ ΕΠΙΠΕΔΟΥ
	var planeMaterial = new THREE.MeshLambertMaterial({
		color: 0xaa0000,
		map: THREE.ImageUtils.loadTexture("js/fora.png"),
		side:THREE.DoubleSide,
		transparent: true
	})


	var material = new THREE.MeshBasicMaterial({color: 0xcccccc, side: THREE.DoubleSide});
	var geomety = new THREE.PlaneGeometry( 50, 50, 1, 1 );
	geomety.applyMatrix( new THREE.Matrix4().makeRotationX( Math.PI/2  ) );
	plane = new THREE.Mesh(geomety, material);

	var geomety2 = new THREE.PlaneGeometry( 50, 50, 1, 1 );
	geomety2.applyMatrix( new THREE.Matrix4().makeRotationX( -Math.PI/2  ) );
	plane2 = new THREE.Mesh(geomety2, planeMaterial);
	plane.add(plane2)
	plane2.position.set(0,0.6,0)
	
	//plane.overdraw = true;
	scene.add(plane);
	Obj = new THREE.Object3D();
	

	// ΚΑΘΕΤΟ ΔΙΑΝΥΣΜΑ
	BVecY2 = new THREE.myVector( new THREE.Vector3( 0, 1, 0 ), new THREE.Vector3( 0, 0.01, 0 ), 15 , 0.5);
	BVecY2.setColor(0x0000ff);
	Obj.add(BVecY2);
	scene.add(Obj)


	var material1 = new THREE.MeshLambertMaterial({
		map: THREE.ImageUtils.loadTexture("js/B.png"),
		side:THREE.DoubleSide,
		transparent: true
	})

	var material2 = new THREE.MeshLambertMaterial({
		map: THREE.ImageUtils.loadTexture("js/n.png"),
		side:THREE.DoubleSide,
		transparent: true
	})

	var geometry1 = new THREE.PlaneGeometry(4, 8);
	textB = new THREE.Mesh(geometry1, material1);


	var geometry2 = new THREE.PlaneGeometry(4, 8)
	textn = new THREE.Mesh(geometry2, material2);
	
	textn.position.set(0,17,-3);
	textn.rotation.set(0,Math.PI/3,0);

	BVecY2.add(textn);

	updateAngle(0);
	document.getElementById('bottomTxt').innerHTML="Φ="+(B*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	drawMagneticField();

	// WebGl - Canvas Rendering
	if ( ! Detector.webgl ) {
		renderer = new THREE.CanvasRenderer();
	} else {
		renderer = new THREE.WebGLRenderer( { antialias: true } );
	}
	renderer.setSize( dx, dy );

	// Controls
	container.appendChild( renderer.domElement );
	//window.addEventListener( 'resize', onWindowResize, false );
	
	// Controls 
	controls = new THREE.TrackballControls( camera, renderer.domElement );
	/*controls.target.set( 0, 0, 0 );
	controls.rotateSpeed = 0.2;
	controls.zoomSpeed = 0.2;
	controls.panSpeed = 0.2;
	controls.noZoom = false;
	controls.noPan = false;
	controls.staticMoving = false;
	controls.dynamicDampingFactor = 0.5;*/
	
	// ΓΙΑ Orbit COntrol
	controls = new THREE.OrbitControls( camera , renderer.domElement );
}

/*function onWindowResize() {
	dx=window.innerWidth;
	dy=window.innerHeight;
	camera.aspect = dx/dy
	camera.updateProjectionMatrix();
	renderer.setSize( dx,dy);
	render();
}*/
// ΣΧΕΔΙΑΣΗ ΓΩΝΙΑΣ
function updateAngle(θ) {
	BVecY2.remove(angle );
	if (B!=0) {
		var material = new THREE.MeshBasicMaterial({color: 0x000099, side: THREE.DoubleSide});
		var α1=θ//myControls['Γωνία περιστροφής']*Math.PI/180;
		var startAngle=Math.PI/2-α1;
		var finishAngle=α1;
		
		if (α1>Math.PI) { 
			α1=2*Math.PI-α1+Math.PI/2;
			startAngle=α1;
			finishAngle=Math.PI/2-α1;
		}
		
		angle = new THREE.Mesh(new THREE.CircleGeometry( 7, 25, startAngle,finishAngle), material);
		angle.rotation.y=Math.PI/2;
		BVecY2.add(angle);
	}
}

// ΣΧΕΔΙΑΣΗ ΔΥΝΑΜΙΚΩΝ ΓΡΑΜΜΩΝ
function drawMagneticField() {
	scene.remove(BVec );
	angle.visible=false
	if (B!=0) {
		angle.visible=true;
		dLB=6*5/B;
		nB=Math.round(Math.sqrt(A)*25/dLB);
		
		BVec = new THREE.myVector( new THREE.Vector3( 0, 1, 0 ), new THREE.Vector3( 0, 0, 0.02 ), B*10 , 0.4);
		BVec.setColor(0x009900);
		scene.add(BVec);

		//textB.position.set(2,B*10+2,0)
		textB.rotation.set(0,Math.PI/3,0)
		textB.position.set(0,B*10+4,2)
		BVec.add(textB);


		if (fieldShowFlag) {
			for (var i=-nB;i<=nB;i++) {
				for (var j=-nB;j<=nB;j++) {
					var BVec2 = new THREE.myVector( new THREE.Vector3( 0, 1, 0 ), new THREE.Vector3( i*dLB, -40, j*dLB ), 80 , 0.2);
					BVec2.setColor(0x999999,1);
					BVec.add(BVec2);
				}
			}
		}
	}
}

// ΣΕ ΚΑΘΕ FRAME
function animate() {
	requestAnimationFrame( animate );
	render();
	update();	
}
function render() {
	//var timer = Date.now() * 0.0005;
	//camera.position.z = Math.cos( timer ) * 200;
	//camera.position.x = Math.sin( timer ) * 200;
	camera.lookAt( scene.position );
	renderer.render( scene, camera );

	//console.log(camera.rotation.x+","+camera.rotation.y+","+camera.rotation.z)
}
function update() {
	controls.update();
	if (θ!=myControls['Γωνία περιστροφής']) {
		θ=myControls['Γωνία περιστροφής']
		updateAngle(θ*toRad);
		document.getElementById('bottomTxt').innerHTML="Φ="+(B*A*Math.cos(θ*toRad)).toFixed(1)+" mWb"
	}
	plane.rotation.x = θ*Math.PI/180;
	Obj.rotation.x = θ*Math.PI/180;
}